# coding: utf-8

"""
    Form Service API

    A list of form and Xaas APIs.  This page describes the RESTful APIs for Form Service. The APIs facilitate CRUD operations on the various resources and entities used throughout Form service (Custom Resource , Form Definition etc.) and allow operations on them (creating custom resource type , fetch form status etc.).  Some of the APIs that list collections of resources also support OData like implementation. Below query params can be used across Form and XaaS entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/form-service/api/custom/resource-types?$orderby=name%20DESC```  2. `page`, `size` - page used in conjunction with `size` helps in pagination of resources.      ```/form-service/api/custom/resource-types?page=0&size=20```   # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class FormserviceapicustomresourcetypesProperties(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'type': 'str',
        'encrypted': 'bool',
        'additional_properties': 'bool',
        'title': 'str',
        'description': 'str',
        'write_only': 'bool',
        'read_only': 'bool',
        'any_of': 'list[ProviderSchemaImpl]',
        'one_of': 'list[ProviderSchemaImpl]',
        '_not': 'ProviderSchemaImpl',
        'items': 'FormserviceapicustomresourcetypesPropertiesItems',
        'unique_items': 'bool',
        'max_items': 'int',
        'min_items': 'int',
        'maximum': 'float',
        'exclusive_maximum': 'float',
        'minimum': 'float',
        'exclusive_minimum': 'float',
        'properties': 'dict(str, ProviderSchemaImpl)',
        'required': 'list[str]',
        'max_properties': 'int',
        'min_properties': 'int',
        'pattern_properties': 'dict(str, ProviderSchemaImpl)',
        'max_length': 'int',
        'min_length': 'int',
        'pattern': 'str',
        'format': 'str',
        'format_minimum': 'str',
        'format_maximum': 'str',
        'computed': 'bool',
        'recreate_on_update': 'bool',
        'ignore_on_update': 'bool',
        'ignore_case_on_diff': 'bool',
        'dependencies': 'dict(str, list[str])',
        'enum': 'list[object]',
        'const': 'object',
        'default': 'object',
        'data': 'str',
        'dynamic_default': 'str'
    }

    attribute_map = {
        'type': 'type',
        'encrypted': 'encrypted',
        'additional_properties': 'additionalProperties',
        'title': 'title',
        'description': 'description',
        'write_only': 'writeOnly',
        'read_only': 'readOnly',
        'any_of': 'anyOf',
        'one_of': 'oneOf',
        '_not': 'not',
        'items': 'items',
        'unique_items': 'uniqueItems',
        'max_items': 'maxItems',
        'min_items': 'minItems',
        'maximum': 'maximum',
        'exclusive_maximum': 'exclusiveMaximum',
        'minimum': 'minimum',
        'exclusive_minimum': 'exclusiveMinimum',
        'properties': 'properties',
        'required': 'required',
        'max_properties': 'maxProperties',
        'min_properties': 'minProperties',
        'pattern_properties': 'patternProperties',
        'max_length': 'maxLength',
        'min_length': 'minLength',
        'pattern': 'pattern',
        'format': 'format',
        'format_minimum': 'formatMinimum',
        'format_maximum': 'formatMaximum',
        'computed': 'computed',
        'recreate_on_update': 'recreateOnUpdate',
        'ignore_on_update': 'ignoreOnUpdate',
        'ignore_case_on_diff': 'ignoreCaseOnDiff',
        'dependencies': 'dependencies',
        'enum': 'enum',
        'const': 'const',
        'default': 'default',
        'data': '$data',
        'dynamic_default': '$dynamicDefault'
    }

    def __init__(self, type=None, encrypted=None, additional_properties=None, title=None, description=None, write_only=None, read_only=None, any_of=None, one_of=None, _not=None, items=None, unique_items=None, max_items=None, min_items=None, maximum=None, exclusive_maximum=None, minimum=None, exclusive_minimum=None, properties=None, required=None, max_properties=None, min_properties=None, pattern_properties=None, max_length=None, min_length=None, pattern=None, format=None, format_minimum=None, format_maximum=None, computed=None, recreate_on_update=None, ignore_on_update=None, ignore_case_on_diff=None, dependencies=None, enum=None, const=None, default=None, data=None, dynamic_default=None):  # noqa: E501
        """FormserviceapicustomresourcetypesProperties - a model defined in Swagger"""  # noqa: E501
        self._type = None
        self._encrypted = None
        self._additional_properties = None
        self._title = None
        self._description = None
        self._write_only = None
        self._read_only = None
        self._any_of = None
        self._one_of = None
        self.__not = None
        self._items = None
        self._unique_items = None
        self._max_items = None
        self._min_items = None
        self._maximum = None
        self._exclusive_maximum = None
        self._minimum = None
        self._exclusive_minimum = None
        self._properties = None
        self._required = None
        self._max_properties = None
        self._min_properties = None
        self._pattern_properties = None
        self._max_length = None
        self._min_length = None
        self._pattern = None
        self._format = None
        self._format_minimum = None
        self._format_maximum = None
        self._computed = None
        self._recreate_on_update = None
        self._ignore_on_update = None
        self._ignore_case_on_diff = None
        self._dependencies = None
        self._enum = None
        self._const = None
        self._default = None
        self._data = None
        self._dynamic_default = None
        self.discriminator = None
        if type is not None:
            self.type = type
        if encrypted is not None:
            self.encrypted = encrypted
        if additional_properties is not None:
            self.additional_properties = additional_properties
        if title is not None:
            self.title = title
        if description is not None:
            self.description = description
        if write_only is not None:
            self.write_only = write_only
        if read_only is not None:
            self.read_only = read_only
        if any_of is not None:
            self.any_of = any_of
        if one_of is not None:
            self.one_of = one_of
        if _not is not None:
            self._not = _not
        if items is not None:
            self.items = items
        if unique_items is not None:
            self.unique_items = unique_items
        if max_items is not None:
            self.max_items = max_items
        if min_items is not None:
            self.min_items = min_items
        if maximum is not None:
            self.maximum = maximum
        if exclusive_maximum is not None:
            self.exclusive_maximum = exclusive_maximum
        if minimum is not None:
            self.minimum = minimum
        if exclusive_minimum is not None:
            self.exclusive_minimum = exclusive_minimum
        if properties is not None:
            self.properties = properties
        if required is not None:
            self.required = required
        if max_properties is not None:
            self.max_properties = max_properties
        if min_properties is not None:
            self.min_properties = min_properties
        if pattern_properties is not None:
            self.pattern_properties = pattern_properties
        if max_length is not None:
            self.max_length = max_length
        if min_length is not None:
            self.min_length = min_length
        if pattern is not None:
            self.pattern = pattern
        if format is not None:
            self.format = format
        if format_minimum is not None:
            self.format_minimum = format_minimum
        if format_maximum is not None:
            self.format_maximum = format_maximum
        if computed is not None:
            self.computed = computed
        if recreate_on_update is not None:
            self.recreate_on_update = recreate_on_update
        if ignore_on_update is not None:
            self.ignore_on_update = ignore_on_update
        if ignore_case_on_diff is not None:
            self.ignore_case_on_diff = ignore_case_on_diff
        if dependencies is not None:
            self.dependencies = dependencies
        if enum is not None:
            self.enum = enum
        if const is not None:
            self.const = const
        if default is not None:
            self.default = default
        if data is not None:
            self.data = data
        if dynamic_default is not None:
            self.dynamic_default = dynamic_default

    @property
    def type(self):
        """Gets the type of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The type of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this FormserviceapicustomresourcetypesProperties.


        :param type: The type of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: str
        """
        allowed_values = ["STRING", "INTEGER", "NUMBER", "BOOLEAN", "OBJECT", "ARRAY", "NULL"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def encrypted(self):
        """Gets the encrypted of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The encrypted of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: bool
        """
        return self._encrypted

    @encrypted.setter
    def encrypted(self, encrypted):
        """Sets the encrypted of this FormserviceapicustomresourcetypesProperties.


        :param encrypted: The encrypted of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: bool
        """

        self._encrypted = encrypted

    @property
    def additional_properties(self):
        """Gets the additional_properties of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The additional_properties of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: bool
        """
        return self._additional_properties

    @additional_properties.setter
    def additional_properties(self, additional_properties):
        """Sets the additional_properties of this FormserviceapicustomresourcetypesProperties.


        :param additional_properties: The additional_properties of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: bool
        """

        self._additional_properties = additional_properties

    @property
    def title(self):
        """Gets the title of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The title of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this FormserviceapicustomresourcetypesProperties.


        :param title: The title of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: str
        """

        self._title = title

    @property
    def description(self):
        """Gets the description of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The description of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this FormserviceapicustomresourcetypesProperties.


        :param description: The description of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def write_only(self):
        """Gets the write_only of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The write_only of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: bool
        """
        return self._write_only

    @write_only.setter
    def write_only(self, write_only):
        """Sets the write_only of this FormserviceapicustomresourcetypesProperties.


        :param write_only: The write_only of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: bool
        """

        self._write_only = write_only

    @property
    def read_only(self):
        """Gets the read_only of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The read_only of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: bool
        """
        return self._read_only

    @read_only.setter
    def read_only(self, read_only):
        """Sets the read_only of this FormserviceapicustomresourcetypesProperties.


        :param read_only: The read_only of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: bool
        """

        self._read_only = read_only

    @property
    def any_of(self):
        """Gets the any_of of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The any_of of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: list[ProviderSchemaImpl]
        """
        return self._any_of

    @any_of.setter
    def any_of(self, any_of):
        """Sets the any_of of this FormserviceapicustomresourcetypesProperties.


        :param any_of: The any_of of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: list[ProviderSchemaImpl]
        """

        self._any_of = any_of

    @property
    def one_of(self):
        """Gets the one_of of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The one_of of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: list[ProviderSchemaImpl]
        """
        return self._one_of

    @one_of.setter
    def one_of(self, one_of):
        """Sets the one_of of this FormserviceapicustomresourcetypesProperties.


        :param one_of: The one_of of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: list[ProviderSchemaImpl]
        """

        self._one_of = one_of

    @property
    def _not(self):
        """Gets the _not of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The _not of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: ProviderSchemaImpl
        """
        return self.__not

    @_not.setter
    def _not(self, _not):
        """Sets the _not of this FormserviceapicustomresourcetypesProperties.


        :param _not: The _not of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: ProviderSchemaImpl
        """

        self.__not = _not

    @property
    def items(self):
        """Gets the items of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The items of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: FormserviceapicustomresourcetypesPropertiesItems
        """
        return self._items

    @items.setter
    def items(self, items):
        """Sets the items of this FormserviceapicustomresourcetypesProperties.


        :param items: The items of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: FormserviceapicustomresourcetypesPropertiesItems
        """

        self._items = items

    @property
    def unique_items(self):
        """Gets the unique_items of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The unique_items of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: bool
        """
        return self._unique_items

    @unique_items.setter
    def unique_items(self, unique_items):
        """Sets the unique_items of this FormserviceapicustomresourcetypesProperties.


        :param unique_items: The unique_items of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: bool
        """

        self._unique_items = unique_items

    @property
    def max_items(self):
        """Gets the max_items of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The max_items of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: int
        """
        return self._max_items

    @max_items.setter
    def max_items(self, max_items):
        """Sets the max_items of this FormserviceapicustomresourcetypesProperties.


        :param max_items: The max_items of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: int
        """

        self._max_items = max_items

    @property
    def min_items(self):
        """Gets the min_items of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The min_items of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: int
        """
        return self._min_items

    @min_items.setter
    def min_items(self, min_items):
        """Sets the min_items of this FormserviceapicustomresourcetypesProperties.


        :param min_items: The min_items of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: int
        """

        self._min_items = min_items

    @property
    def maximum(self):
        """Gets the maximum of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The maximum of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: float
        """
        return self._maximum

    @maximum.setter
    def maximum(self, maximum):
        """Sets the maximum of this FormserviceapicustomresourcetypesProperties.


        :param maximum: The maximum of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: float
        """

        self._maximum = maximum

    @property
    def exclusive_maximum(self):
        """Gets the exclusive_maximum of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The exclusive_maximum of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: float
        """
        return self._exclusive_maximum

    @exclusive_maximum.setter
    def exclusive_maximum(self, exclusive_maximum):
        """Sets the exclusive_maximum of this FormserviceapicustomresourcetypesProperties.


        :param exclusive_maximum: The exclusive_maximum of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: float
        """

        self._exclusive_maximum = exclusive_maximum

    @property
    def minimum(self):
        """Gets the minimum of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The minimum of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: float
        """
        return self._minimum

    @minimum.setter
    def minimum(self, minimum):
        """Sets the minimum of this FormserviceapicustomresourcetypesProperties.


        :param minimum: The minimum of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: float
        """

        self._minimum = minimum

    @property
    def exclusive_minimum(self):
        """Gets the exclusive_minimum of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The exclusive_minimum of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: float
        """
        return self._exclusive_minimum

    @exclusive_minimum.setter
    def exclusive_minimum(self, exclusive_minimum):
        """Sets the exclusive_minimum of this FormserviceapicustomresourcetypesProperties.


        :param exclusive_minimum: The exclusive_minimum of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: float
        """

        self._exclusive_minimum = exclusive_minimum

    @property
    def properties(self):
        """Gets the properties of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The properties of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: dict(str, ProviderSchemaImpl)
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this FormserviceapicustomresourcetypesProperties.


        :param properties: The properties of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: dict(str, ProviderSchemaImpl)
        """

        self._properties = properties

    @property
    def required(self):
        """Gets the required of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The required of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: list[str]
        """
        return self._required

    @required.setter
    def required(self, required):
        """Sets the required of this FormserviceapicustomresourcetypesProperties.


        :param required: The required of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: list[str]
        """

        self._required = required

    @property
    def max_properties(self):
        """Gets the max_properties of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The max_properties of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: int
        """
        return self._max_properties

    @max_properties.setter
    def max_properties(self, max_properties):
        """Sets the max_properties of this FormserviceapicustomresourcetypesProperties.


        :param max_properties: The max_properties of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: int
        """

        self._max_properties = max_properties

    @property
    def min_properties(self):
        """Gets the min_properties of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The min_properties of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: int
        """
        return self._min_properties

    @min_properties.setter
    def min_properties(self, min_properties):
        """Sets the min_properties of this FormserviceapicustomresourcetypesProperties.


        :param min_properties: The min_properties of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: int
        """

        self._min_properties = min_properties

    @property
    def pattern_properties(self):
        """Gets the pattern_properties of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The pattern_properties of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: dict(str, ProviderSchemaImpl)
        """
        return self._pattern_properties

    @pattern_properties.setter
    def pattern_properties(self, pattern_properties):
        """Sets the pattern_properties of this FormserviceapicustomresourcetypesProperties.


        :param pattern_properties: The pattern_properties of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: dict(str, ProviderSchemaImpl)
        """

        self._pattern_properties = pattern_properties

    @property
    def max_length(self):
        """Gets the max_length of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The max_length of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: int
        """
        return self._max_length

    @max_length.setter
    def max_length(self, max_length):
        """Sets the max_length of this FormserviceapicustomresourcetypesProperties.


        :param max_length: The max_length of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: int
        """

        self._max_length = max_length

    @property
    def min_length(self):
        """Gets the min_length of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The min_length of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: int
        """
        return self._min_length

    @min_length.setter
    def min_length(self, min_length):
        """Sets the min_length of this FormserviceapicustomresourcetypesProperties.


        :param min_length: The min_length of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: int
        """

        self._min_length = min_length

    @property
    def pattern(self):
        """Gets the pattern of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The pattern of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: str
        """
        return self._pattern

    @pattern.setter
    def pattern(self, pattern):
        """Sets the pattern of this FormserviceapicustomresourcetypesProperties.


        :param pattern: The pattern of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: str
        """

        self._pattern = pattern

    @property
    def format(self):
        """Gets the format of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The format of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: str
        """
        return self._format

    @format.setter
    def format(self, format):
        """Sets the format of this FormserviceapicustomresourcetypesProperties.


        :param format: The format of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: str
        """

        self._format = format

    @property
    def format_minimum(self):
        """Gets the format_minimum of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The format_minimum of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: str
        """
        return self._format_minimum

    @format_minimum.setter
    def format_minimum(self, format_minimum):
        """Sets the format_minimum of this FormserviceapicustomresourcetypesProperties.


        :param format_minimum: The format_minimum of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: str
        """

        self._format_minimum = format_minimum

    @property
    def format_maximum(self):
        """Gets the format_maximum of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The format_maximum of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: str
        """
        return self._format_maximum

    @format_maximum.setter
    def format_maximum(self, format_maximum):
        """Sets the format_maximum of this FormserviceapicustomresourcetypesProperties.


        :param format_maximum: The format_maximum of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: str
        """

        self._format_maximum = format_maximum

    @property
    def computed(self):
        """Gets the computed of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The computed of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: bool
        """
        return self._computed

    @computed.setter
    def computed(self, computed):
        """Sets the computed of this FormserviceapicustomresourcetypesProperties.


        :param computed: The computed of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: bool
        """

        self._computed = computed

    @property
    def recreate_on_update(self):
        """Gets the recreate_on_update of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The recreate_on_update of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: bool
        """
        return self._recreate_on_update

    @recreate_on_update.setter
    def recreate_on_update(self, recreate_on_update):
        """Sets the recreate_on_update of this FormserviceapicustomresourcetypesProperties.


        :param recreate_on_update: The recreate_on_update of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: bool
        """

        self._recreate_on_update = recreate_on_update

    @property
    def ignore_on_update(self):
        """Gets the ignore_on_update of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The ignore_on_update of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: bool
        """
        return self._ignore_on_update

    @ignore_on_update.setter
    def ignore_on_update(self, ignore_on_update):
        """Sets the ignore_on_update of this FormserviceapicustomresourcetypesProperties.


        :param ignore_on_update: The ignore_on_update of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: bool
        """

        self._ignore_on_update = ignore_on_update

    @property
    def ignore_case_on_diff(self):
        """Gets the ignore_case_on_diff of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The ignore_case_on_diff of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: bool
        """
        return self._ignore_case_on_diff

    @ignore_case_on_diff.setter
    def ignore_case_on_diff(self, ignore_case_on_diff):
        """Sets the ignore_case_on_diff of this FormserviceapicustomresourcetypesProperties.


        :param ignore_case_on_diff: The ignore_case_on_diff of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: bool
        """

        self._ignore_case_on_diff = ignore_case_on_diff

    @property
    def dependencies(self):
        """Gets the dependencies of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The dependencies of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: dict(str, list[str])
        """
        return self._dependencies

    @dependencies.setter
    def dependencies(self, dependencies):
        """Sets the dependencies of this FormserviceapicustomresourcetypesProperties.


        :param dependencies: The dependencies of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: dict(str, list[str])
        """

        self._dependencies = dependencies

    @property
    def enum(self):
        """Gets the enum of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The enum of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: list[object]
        """
        return self._enum

    @enum.setter
    def enum(self, enum):
        """Sets the enum of this FormserviceapicustomresourcetypesProperties.


        :param enum: The enum of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: list[object]
        """

        self._enum = enum

    @property
    def const(self):
        """Gets the const of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The const of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: object
        """
        return self._const

    @const.setter
    def const(self, const):
        """Sets the const of this FormserviceapicustomresourcetypesProperties.


        :param const: The const of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: object
        """

        self._const = const

    @property
    def default(self):
        """Gets the default of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The default of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: object
        """
        return self._default

    @default.setter
    def default(self, default):
        """Sets the default of this FormserviceapicustomresourcetypesProperties.


        :param default: The default of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: object
        """

        self._default = default

    @property
    def data(self):
        """Gets the data of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The data of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: str
        """
        return self._data

    @data.setter
    def data(self, data):
        """Sets the data of this FormserviceapicustomresourcetypesProperties.


        :param data: The data of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: str
        """

        self._data = data

    @property
    def dynamic_default(self):
        """Gets the dynamic_default of this FormserviceapicustomresourcetypesProperties.  # noqa: E501


        :return: The dynamic_default of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :rtype: str
        """
        return self._dynamic_default

    @dynamic_default.setter
    def dynamic_default(self, dynamic_default):
        """Sets the dynamic_default of this FormserviceapicustomresourcetypesProperties.


        :param dynamic_default: The dynamic_default of this FormserviceapicustomresourcetypesProperties.  # noqa: E501
        :type: str
        """

        self._dynamic_default = dynamic_default

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FormserviceapicustomresourcetypesProperties, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FormserviceapicustomresourcetypesProperties):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
